# all files / ol/geom/ multipoint.js

92.77% Statements 77/83
70% Branches 14/20
90.91% Functions 10/11
92.77% Lines 77/83

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    1971×

    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×
    63×
    63×

    1×

    1×
    2×

    2×

    2×

    2×

    1×

    1×
    1×

    1×
    1×
    1×
    1×
    2×

    2×
    2×
    2×
    8×

    2×

    1×

    1×
    31×

    1×
    2×

    2×

    2×

    2×
    2×

    2×

    1×
    9×
    9×
    9×

    9×
    9×
    9×
    21×
    21×
    21×

    9×

    1×
    13×

    1×
    2×
    2×
    2×
    2×
    3×
    3×
    3×
    1×

    1×

    1×
    63×
    2×

    61×
    61×
    61×

    61×

    61×

    1×
    3×
    3×

     goog.provide('ol.geom.MultiPoint');

    goog.require('goog.asserts');
    goog.require('ol.array');
    goog.require('ol.extent');
    goog.require('ol.geom.GeometryLayout');
    goog.require('ol.geom.GeometryType');
    goog.require('ol.geom.Point');
    goog.require('ol.geom.SimpleGeometry');
    goog.require('ol.geom.flat.deflate');
    goog.require('ol.geom.flat.inflate');
    goog.require('ol.math');

    /**
     * @classdesc
     * Multi-point geometry.
     *
     * @constructor
     * @extends {ol.geom.SimpleGeometry}
     * @param {Array.<ol.Coordinate>} coordinates Coordinates.
     * @param {ol.geom.GeometryLayout=} opt_layout Layout.
     * @api stable
     */
    ol.geom.MultiPoint = function(coordinates, opt_layout) {
      goog.base(this);
      this.setCoordinates(coordinates, opt_layout);
    };
    goog.inherits(ol.geom.MultiPoint, ol.geom.SimpleGeometry);

    /**
     * Append the passed point to this multipoint.
     * @param {ol.geom.Point} point Point.
     * @api stable
     */
    ol.geom.MultiPoint.prototype.appendPoint = function(point) {
      goog.asserts.assert(point.getLayout() == this.layout,
          'the layout of point should match layout');
      Iif (!this.flatCoordinates) {
        this.flatCoordinates = point.getFlatCoordinates().slice();
      } else {
        ol.array.extend(this.flatCoordinates, point.getFlatCoordinates());
      }
      this.changed();
    };

    /**
     * Make a complete copy of the geometry.
     * @return {!ol.geom.MultiPoint} Clone.
     * @api stable
     */
    ol.geom.MultiPoint.prototype.clone = function() {
      var multiPoint = new ol.geom.MultiPoint(null);
      multiPoint.setFlatCoordinates(this.layout, this.flatCoordinates.slice());
      return multiPoint;
    };

    /**
     * @inheritDoc
     */
    ol.geom.MultiPoint.prototype.closestPointXY = function(x, y, closestPoint, minSquaredDistance) {
      Iif (minSquaredDistance <
          ol.extent.closestSquaredDistanceXY(this.getExtent(), x, y)) {
        return minSquaredDistance;
      }
      var flatCoordinates = this.flatCoordinates;
      var stride = this.stride;
      var i, ii, j;
      for (i = 0, ii = flatCoordinates.length; i < ii; i += stride) {
        var squaredDistance = ol.math.squaredDistance(
            x, y, flatCoordinates[i], flatCoordinates[i + 1]);
        Eif (squaredDistance < minSquaredDistance) {
          minSquaredDistance = squaredDistance;
          for (j = 0; j < stride; ++j) {
            closestPoint[j] = flatCoordinates[i + j];
          }
          closestPoint.length = stride;
        }
      }
      return minSquaredDistance;
    };

    /**
     * Return the coordinates of the multipoint.
     * @return {Array.<ol.Coordinate>} Coordinates.
     * @api stable
     */
    ol.geom.MultiPoint.prototype.getCoordinates = function() {
      return ol.geom.flat.inflate.coordinates(
          this.flatCoordinates, 0, this.flatCoordinates.length, this.stride);
    };

    /**
     * Return the point at the specified index.
     * @param {number} index Index.
     * @return {ol.geom.Point} Point.
     * @api stable
     */
    ol.geom.MultiPoint.prototype.getPoint = function(index) {
      var n = !this.flatCoordinates ?
          0 : this.flatCoordinates.length / this.stride;
      goog.asserts.assert(0 <= index && index < n,
          'index should be in between 0 and n');
      Iif (index < 0 || n <= index) {
        return null;
      }
      var point = new ol.geom.Point(null);
      point.setFlatCoordinates(this.layout, this.flatCoordinates.slice(
          index * this.stride, (index + 1) * this.stride));
      return point;
    };

    /**
     * Return the points of this multipoint.
     * @return {Array.<ol.geom.Point>} Points.
     * @api stable
     */
    ol.geom.MultiPoint.prototype.getPoints = function() {
      var flatCoordinates = this.flatCoordinates;
      var layout = this.layout;
      var stride = this.stride;
      /** @type {Array.<ol.geom.Point>} */
      var points = [];
      var i, ii;
      for (i = 0, ii = flatCoordinates.length; i < ii; i += stride) {
        var point = new ol.geom.Point(null);
        point.setFlatCoordinates(layout, flatCoordinates.slice(i, i + stride));
        points.push(point);
      }
      return points;
    };

    /**
     * @inheritDoc
     * @api stable
     */
    ol.geom.MultiPoint.prototype.getType = function() {
      return ol.geom.GeometryType.MULTI_POINT;
    };

    /**
     * @inheritDoc
     * @api stable
     */
    ol.geom.MultiPoint.prototype.intersectsExtent = function(extent) {
      var flatCoordinates = this.flatCoordinates;
      var stride = this.stride;
      var i, ii, x, y;
      for (i = 0, ii = flatCoordinates.length; i < ii; i += stride) {
        x = flatCoordinates[i];
        y = flatCoordinates[i + 1];
        if (ol.extent.containsXY(extent, x, y)) {
          return true;
        }
      }
      return false;
    };

    /**
     * Set the coordinates of the multipoint.
     * @param {Array.<ol.Coordinate>} coordinates Coordinates.
     * @param {ol.geom.GeometryLayout=} opt_layout Layout.
     * @api stable
     */
    ol.geom.MultiPoint.prototype.setCoordinates = function(coordinates, opt_layout) {
      if (!coordinates) {
        this.setFlatCoordinates(ol.geom.GeometryLayout.XY, null);
      } else {
        this.setLayout(opt_layout, coordinates, 1);
        Eif (!this.flatCoordinates) {
          this.flatCoordinates = [];
        }
        this.flatCoordinates.length = ol.geom.flat.deflate.coordinates(
            this.flatCoordinates, 0, coordinates, this.stride);
        this.changed();
      }
    };

    /**
     * @param {ol.geom.GeometryLayout} layout Layout.
     * @param {Array.<number>} flatCoordinates Flat coordinates.
     */
    ol.geom.MultiPoint.prototype.setFlatCoordinates = function(layout, flatCoordinates) {
      this.setFlatCoordinatesInternal(layout, flatCoordinates);
      this.changed();
    };